//----------------------------------------------------------------
/* THE_POKER
/*   Oh!X 1991/2
// V3.20以降専用
//----------------------------------------------------------------

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

if cardInit()<>0 then {
	print localizedString("カードパターンが読めません","Card data can not read.")
	end
}

//----------------------------------------------------------------
// 以下ゲーム実体
//----------------------------------------------------------------
// お約束部分
enum
	FNTSZ=16
	KEY_SPACE=' '
	KEY_OK   ='D'
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
// 以下テキスト描画はグラフィックモードで行う(X68のプログラムのままではグラフィックとテキストで座標が合わないので)
width(0)
tAtrb(ATRB_CLEAR):// グラフィックモードでテキスト文字の下地を消す

vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)

// bitmapOpen()はページ毎に行う必要がある
apage(GPAGE3):bitmapOpen(0,0,YES)
apage(GPAGE2):bitmapOpen(0,0,YES)
apage(GPAGE1):bitmapOpen(0,0,YES)
apage(GPAGE0):bitmapOpen(0,0,YES)

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

dim int	touchNo(20)	:// タッチエリア番号 / touch area number
int touchallcnt=0	:// タッチエリア数   / the number of touch area

//----------------------------------------------------------------

int kin,kake,up,max
int c_cnt,round
int mx,my,x,y,lb,rb
dim str yaku(7) = {"ROYAL STRAIGHT FLUSH",
	"STRAIGHT FLUSH",
	"FOUR CARD",
	"FULL HOUSE",
	"STRAIGHT",
	"FLUSH",
	"THREE CARD",
	"TWO PAIR"
}
dim int ritsu(7)={500,100,40,10,7,5,3,2}
dim int zahyou(4)={88,160,232,304,376}
dim int tmp(5,1),cc(5),c(51)
dim str m(12)


// 音声データ読み込み
int snd_pasa =a_setPlayData("pasa.mp3")
int snd_atari=a_setPlayData("atari.mp3")
int snd_wake =a_setPlayData("wake.mp3")

init()
nv_init()
gamen()
jyunbi()
repeat
	repeat
		shuffle()
		c_hyouji(0)
		bet()
		game()
		round=round+1
	until kin=0 or kin>=10000
until over()=YES

apage(GPAGE1):wipe()
apage(GPAGE0):wipe()
cls()
tColorX68(3)

// 音声バッファー開放
a_end(snd_pasa)
a_end(snd_atari)
a_end(snd_wake)

// bitmapはページごとに確保されているので、それぞれを開放する必要がある
apage(GPAGE3):bitmapClose()
apage(GPAGE2):bitmapClose()
apage(GPAGE1):bitmapClose()
apage(GPAGE0):bitmapClose()

end

//----------------------------------------------------------------

func bet()
/* お金を賭ける
int i,ky
	s_hyouji(1,7,0)
	if kin>=1000 then up=100 else up=10
	if kin<=100  then max=50 else max=kin/2

	setFunctionKey(0,localizedString("決定","Determin"),KEY_OK)
	displayFunctionKey(YES,0,0)
	
	kbclr()
	repeat
		// タッチされるまで待つ
		repeat
			ky=inkey()
			if ky=KEY_OK then break
		until getTouchStatus()<>TOUCH_NONE
		if ky=KEY_OK then break

		int sx,sy,ex,ey

		dim float tpoint(1)
		int touchCnt=getTouchPoint(tpoint)
		sx=tpoint(0)
		sy=tpoint(1)
		ex=sx
		ey=sy

		// 離されるまで待つ
		while getTouchStatus()<>TOUCH_NONE
			ky=inkey()
			if ky=KEY_OK then break
		endwhile
		if ky=KEY_OK then break

		touchCnt=getTouchPoint(tpoint,1)
		ex=tpoint(0)
		ey=tpoint(1)

		if ey-sy<0 then {
			// 下向けドラッグ:増加
			if kake+up<=max and kin-up>=0 then {
				kin=kin-up  :m_hyouji()
				beep2(1)
				kake=kake+up:k_hyouji()
				if kake<=100 or (kin>=1000 and kake<=1000) then cwait(2)
			}
		}
		if ey-sy>0 then {
			// 上向けドラッグ:初期化
			kin=kin+kake:m_hyouji()
			beep2(1)
			kake=0		:k_hyouji()
		}
	until kake>0 and inkey()=KEY_OK
	displayFunctionKey(NO)
	//
	for i=0 to 7
		y_hyouji(i,0)
	next
	s_hyouji(0,0,0)
endfunc

//----------------------------------------------------------------

func game()
/* ゲームをする
int i,rank,ky
	c_hyouji(1)
	s_hyouji(2,9,8)
	rank=hantei()
	if rank<>8 then y_hyouji(rank,1)

	setFunctionKey(0,localizedString("決定","Determin"),KEY_OK)
	displayFunctionKey(YES,0,0)
	
	kbclr()
	repeat
		// 前のタップが残っていたら、一旦離すまで待つ
		while getTouchStatus()<>TOUCH_NONE
			ky=inkey()
			if ky=KEY_OK then break
		endwhile
		if ky=KEY_OK then break

		// タッチされるまで待つ
		repeat
			ky=inkey()
			if ky=KEY_OK then break
		until getTouchStatus()<>TOUCH_NONE
		if ky=KEY_OK then break

		dim float tpoint(1)
		int touchCnt=getTouchPoint(tpoint)
		x=tpoint(0)
		y=tpoint(1)

		// どこのカードが押されたか調べる
		for i=0 to 4
			if x>=zahyou(i) and x<zahyou(i)+CARD_WX then {
				hold(i)
				break
			}
		next
	until inkey()=KEY_OK
	displayFunctionKey(NO)
	//
	for i=0 to 4
		if cc(i)=0 then {
			cardPut(88+72*i,256,0,NO)
			cwait(2)
		}
	next
	for i=0 to 4
		if cc(i)=0 then {
			cardPut(88+i*72,256,c(c_cnt),NO)
			oto(snd_pasa)
			cc(5)=c(i):c(i)=c(c_cnt):c(c_cnt)=cc(5)
			c_cnt=c_cnt+1:cwait(2)
		}
	next
	if rank<>8 then y_hyouji(rank,0):// 役表示
	rank=hantei()
//gLocate(0,32):print "rank=";rank
	if rank<>8 then {
		y_hyouji(rank,1):// 役表示
		kake=ritsu(rank)*kake:k_hyouji():// 掛け金表示
		double()
	} else {
		hitKey(NO)
	}
	kake=0:k_hyouji()
	s_hyouji(0,0,0)
	// HOLDを消す
	for i=0 to 4
		gLocate(12+i*9,23)
		print "     "
	next
	jyunbi()
endfunc

//----------------------------------------------------------------

func hold(no;int)
/* 取っておくか調べる
	gLocate(12+no*9,23)
	if cc(no)=0 then {
		cc(no)=1
		print "HOLD"
	} else {
		cc(no)=0
		print "    "
	}
endfunc

//----------------------------------------------------------------

func int hantei()
/* 役の判定
int i,j
	for i=0 to 4
		tmp(i,0)=c(i)/MAX_TRUMP
		tmp(i,1)=c(i) mod MAX_TRUMP
		if tmp(i,1)=0 then tmp(i,0)=tmp(i,0)-1:tmp(i,1)=13
	next
	for i=0 to 3
		for j=i+1 to 4
			if tmp(i,1)>tmp(j,1) then {
				tmp(5,0)=tmp(i,0):tmp(5,1)=tmp(i,1)
				tmp(i,0)=tmp(j,0):tmp(i,1)=tmp(j,1)
				tmp(j,0)=tmp(5,0):tmp(j,1)=tmp(5,1)
			}
		next
	next
	if mark()=1 then {
		if tmp(0,1)=1 and tmp(1,1)=10 and tmp(2,1)=11 and tmp(3,1)=12 and tmp(4,1)=13 then {
			return(0)
		}
		if strate()=1 then return(1)
		return(5)
	}
	if strate()=1 then return(4)
	switch same(0)
		case 3: return(2)
		case 2: if same(3)=1 then return(3)
				return(6)
		case 1:	switch same(2)
					case 2:	return(3)
					case 1:	return(7)
					case 0:	if same(3)=1 then return(7)
							return(8)
				endswitch
		case 0:	switch same(1)
					case 3:	return(2)
					case 2:	return(6)
					case 1:	if same(3)=1 then return(7)
							return(8)
					case 0:	if same(2)=2 then return(6)
							return(8)
				endswitch
	endswitch
	gLocate(0,33)
	print "役の判定〜なし"
	return(0)
endfunc

//----------------------------------------------------------------

func mark()
/* マークが揃っているか調べる
int i
	for i=0 to 3
		if tmp(i,0)<>tmp(i+1,0) then return(0)
	next
	return(1)
endfunc

//----------------------------------------------------------------

func strate()
/* 数字が並んでいるか調べる
int i
	for i=0 to 3
		if abs(tmp(i,1)-tmp(i+1,1))<>1 then return(0)
	next
	if abs(tmp(0,1)-tmp(4,1))=4 then return(1)
	return(0)
endfunc

//----------------------------------------------------------------

func same(st;int)
/* 同じ数字が何枚あるか調べる
int i,cnt=0
	for i=st+1 to 4
		if tmp(st,1)=tmp(i,1) then cnt=cnt+1
	next
	return(cnt)
endfunc

//----------------------------------------------------------------

func double()
/* ボーナスゲームをするか
int end_f=0
	s_hyouji(0,0,0 ):// 前のメッセージを消す
//	s_hyouji(3,4,10)
	
	dim str menues(1)
	str title$
	if isLocalizeJapan() then {
		title$="DOUBLE UPに挑戦しますか？"
		menues={"はい","いいえ"}
	} else {
		title$="Do you challenge double up?"
		menues={"Yes","No"}
	}
	switch selectMenu(title$,menues)
		case 0
			repeat
				end_f=bonus()
			until end_f=0
			break
		case 1
			break
	endswitch

//	repeat
//		msstat(x,y,lb,rb)
//		if lb=-1 then end_f=1
//		while end_f=1
//			end_f=bonus()
//		endwhile
//	until rb=-1

	kin=kin+kake:m_hyouji()
endfunc

//----------------------------------------------------------------

func bonus()
/* ボーナスゲーム
int c1,c2,i
	s_hyouji(0,0,0)
	// HOLDを消す
	for i=0 to 4
		gLocate(12+i*9,23)
		print "    "
	next
	//
	fill16X68(88,256,423,351,8)
	cardPut(160,256,c(c_cnt),NO):oto(snd_pasa):cwait(2)
	c1=check(c(c_cnt))
	c_cnt=c_cnt+1
	cardPut(304,256,0       ,NO):oto(snd_pasa):cwait(2)
	//
//	s_hyouji(3,11,12)
//	cwait(5)
	dim str menues(1)
	str title$
	title$="DOUBLE UP"
	menues={"BIG","SMALL"}
	i=selectMenu(title$,menues)
	//
	cardPut(304,256,c(c_cnt),NO):oto(snd_pasa):cwait(2)
	c2=check(c(c_cnt))
	//
	if (i=0 and c1<c2) or (i=1 and c1>c2) then {
		oto(snd_atari)
		kake=kake*2:k_hyouji()
		//
		if isLocalizeJapan() then {
			title$="賭け金は倍になりました。"+chr$(13)+"もう一度、挑戦しますか？"
			menues={"はい","いいえ"}
		} else {
			title$="Bets is now doubled."+chr$(13)+"Try again?"
			menues={"Yes","No"}
		}
		i=selectMenu(title$,menues)
		if i=0 then c_cnt=c_cnt+1:return(1)
		if i=1 then return(0)
	} else {
		if c1=c2 then {
			c_cnt=c_cnt+1
			oto(snd_wake):cwait(5)
			return(1)
		}
	}
	kake=0
	return(0)
endfunc

//----------------------------------------------------------------

func check(no;int)
/* カードのチェック
	no = no mod MAX_TRUMP
	if no=0 then no=MAX_TRUMP
	if no=1 then no=MAX_TRUMP+1
	if c_cnt=51 then c_cnt=rnd()*52
	return(no)
endfunc

//----------------------------------------------------------------

func int over()
/* ゲーム終了？
	fill16X68(88,256,423,351,8)
	apage(GPAGE0)
	if kin>=10000 then win()
//	s_hyouji(5,0,10)

	dim str menues(1)
	str title$
	if isLocalizeJapan() then {
		title$="もう一度、挑戦しますか？"
		menues={"はい","いいえ"}
	} else {
		title$="Try again?"
		menues={"Yes","No"}
	}
	switch selectMenu(title$,menues)
		case 0
			break
		case 1
			return(YES)
	endswitch
	//
	kin=100
	m_hyouji()
	round=0
//	s_hyouji(0,0,0)
	int i
	for i=0 to 4
		gLocate(23,18+i):print space$(18)
	next
	wipe():apage(GPAGE1)
	return(NO)
endfunc

//----------------------------------------------------------------

func win()
/* 勝ち
	fill16X68(152,232,359,383,4)
	symbol16X68(166,244,"CONGRATULATION!",2,15,FONT,FNTSZ)
	gLocate(23,18):print localizedString("ラウンド数","Round")
	gLocate(38,19):print using "###";round
	gLocate(23,21):print localizedString("Award","")
	gLocate(31,22)
	// 英語モードでは$はusing書式文字になるので対策
	print "$";:print using "######";kin
endfunc

//----------------------------------------------------------------

func c_hyouji(ptn;int)
/* カードの表示
int i
	for i=0 to 4
		if ptn=0 then {
			cardPut(88+i*72,256,0   ,NO)
		} else {
			cardPut(88+i*72,256,c(i),NO)
		}
		oto(snd_pasa):cwait(2)
	next
endfunc

//----------------------------------------------------------------

func y_hyouji(no;int,ptn;int)
/* 役の表示
	if ptn then tColorX68(15)
	gLocate(28,no+1)
	// 英語モードでは$はusing書式文字になるので対策
	print using " &                    &    ";yaku(no);:print "$";:print using "###### ";ritsu(no)*kake
	tColorX68(7)
endfunc

//----------------------------------------------------------------

func s_hyouji(m1;int,m2;int,m3;int)
/* 説明の表示
	gLocate(15,26):print m(m1)
	gLocate(15,27):print m(m2)
	gLocate(15,28):print m(m3)
endfunc

//----------------------------------------------------------------

func m_hyouji()
/* 持ち金の表示
	gLocate(19, 9):print using "######";kin
endfunc

//----------------------------------------------------------------

func k_hyouji()
/* 掛け金の表示
	locate(52*8-3,10*16):print "$";:print using "######";kake
endfunc

//----------------------------------------------------------------

func jyunbi()
/* 次の準備
int i
	c_cnt=5
	for i=0 to 5
		tmp(i,0)=0:tmp(i,1)=0
		cc(i)=0
	next
	for i=0 to 7
		y_hyouji(i,0)
	next
endfunc

//----------------------------------------------------------------

func oto(no;int)
/* 効果音
	a_play(no)
endfunc

//----------------------------------------------------------------

func cwait(w;int)
/* ウエイト
	wait((17.0/101.0)*w)
//	int i
//	for i=0 to w*100:next
endfunc

//----------------------------------------------------------------

func init()
/* 初期設定
	apage(GPAGE1):vpageX68(3)
	tColorX68(7)
	randomize(val(mid$(time$,4,2)+right$(time$,2)))
endfunc

//----------------------------------------------------------------

func nv_init()
/* 初期設定
int i
	for i=0 to 51
		c(i)=i+1
	next
	round=0:kin=100:kake=0:up=10:max=50
	m( 0)="                                   "
	m( 1)=localizedString("賭け金を決めて下さい。","Please choose your bets.")
	m( 2)=localizedString("カードを選んで下さい。","Please select card.")
	m( 7)=localizedString("上下ドラッグ：賭け金を賭ける","Drag up/down:Please take your bets.")
	m( 8)=m(0)://localizedString("[決定]でゲーム開始","[Determin] start game")
	m( 9)=localizedString("タップ：ＨＯＬＤ/ＣＡＮCＥＬ","Tap : HOLD/CANCEL")
	// 以下未使用
//	m( 3)="ＤＯＵＢＬＥ　ＵＰ"
//	m( 4)="　　　　　　　に挑戦しますか？"
//	m( 5)="もう一度、挑戦しますか？"
//	m( 6)="賭け金は倍になりました。"
//	m(10)="左ボタン・YES　右ボタン・ＮＯ"
//	m(11)="左ボタン・ＢＩＧ"
//	m(12)="右ボタン・ＳＭＡＬＬ"
endfunc

//----------------------------------------------------------------

func shuffle()
/* シャッフル
int i,a,b,k
	for i=0 to 99
		a=rnd()*52:b=rnd()*52
		k=c(a):c(a)=c(b):c(b)=k
	next
endfunc

//----------------------------------------------------------------

func gamen()
/* 画面描画
	fill16X68(  0,  0,511,511,3)
	fill16X68(  0,192,511,511,8)
	fill16X68(112,408,399,471,0)
	box16X68(114,412,397,467,15)
	box16X68(219,  8,507,151,15)
	box16X68(219,151,507,182,15)
	box16X68(  5,  8,214,112,15)
	box16X68(  5,120,214,183,15)
	symbol16X68(23,26,"THE"  ,2, 0,FONT,FNTSZ)
	symbol16X68(21,24,"THE"  ,2,13,FONT,FNTSZ)
	symbol16X68(23,52,"POKER",3, 0,FONT,FNTSZ)
	symbol16X68(21,50,"POKER",3,13,FONT,FNTSZ)
	gLocate( 2, 9):print localizedString("あなたの持ち金  $","  Your money  $")
	m_hyouji()
	gLocate(29,10):print localizedString("掛け金","Bet")
	k_hyouji()
endfunc

//****************************************************************
// 補助関数
//****************************************************************

func removeKeys()
// 全タッチアリアの解除 / release all key touch area
// 毎回変わるので重要 / Important because stage is changed every time
	if touchallcnt>0 then {
		int i
		for i=1 to touchallcnt
			removeTouchArea(touchNo(i))
		next
		touchallcnt=0:// 登録してないの印
	}:// すでに解除済みの時は何もしない / if already released, do nothing.
endfunc

//****************************************************************
